unit uCryptoCompare;

{ Dieses Projekt benutzt SetLength() fr Arrays aus Delphi 6. }

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, StdCtrls, Mask, uRC4, uBlowfish, MMSystem, ExtCtrls, uOptions;

type
  TCCMain = class(TForm)
    MainMenu1: TMainMenu;
    Datei1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    ber1: TMenuItem;
    PlaintextOpenDialog: TOpenDialog;
    PlaintextFileNameEdit: TEdit;
    PlaintextBrowseBtn: TButton;
    RC4FileNameEdit: TEdit;
    Label2: TLabel;
    BFFileNameEdit: TEdit;
    Label3: TLabel;
    ResultBox: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    RC4TimeLabel: TLabel;
    BFTimeLabel: TLabel;
    RC4OpenDialog: TOpenDialog;
    BFOpenDialog: TOpenDialog;
    RC4BrowseBtn: TButton;
    BFBrowseBtn: TButton;
    RC4EncryptBtn: TButton;
    RC4DecryptBtn: TButton;
    BFEncryptBtn: TButton;
    BFDecryptBtn: TButton;
    Label1: TLabel;
    Label6: TLabel;
    Key: TEdit;
    Label7: TLabel;
    Panel1: TPanel;
    N3: TMenuItem;
    Geschwindigkeitstest1: TMenuItem;
    Optionen1: TMenuItem;
    procedure N1Click(Sender: TObject);
    procedure PlaintextBrowseBtnClick(Sender: TObject);
    procedure RC4BrowseBtnClick(Sender: TObject);
    procedure BFBrowseBtnClick(Sender: TObject);
    procedure ber1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure RC4EncryptBtnClick(Sender: TObject);
    procedure RC4DecryptBtnClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BFEncryptBtnClick(Sender: TObject);
    procedure BFDecryptBtnClick(Sender: TObject);
    procedure Geschwindigkeitstest1Click(Sender: TObject);
    procedure Optionen1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  CCMain: TCCMain;

implementation

uses uAbout;

{$R *.dfm}

procedure TCCMain.N1Click(Sender: TObject);
begin
  Application.Terminate; // Programm beenden.
end;

procedure TCCMain.PlaintextBrowseBtnClick(Sender: TObject);
begin
  if PlaintextOpenDialog.Execute then
    begin
      PlaintextFileNameEdit.Text := PlaintextOpenDialog.FileName; // Dateiname fr Klartext per Datei-ffnen-Dialog erfragen.
      RC4FileNameEdit.Text := PlaintextFileNameEdit.Text + '.cs2'; // Der Dateiname der RC4/CipherSaber2 verschlsselten Datei ist der des Klartextes mit einem angehngten ".cs2".
      BFFileNameEdit.Text := PlaintextFileNameEdit.Text + '.blf'; // Der Dateiname der *** verschlsselten Datei ist der des Klartextes mit einem angehngten ".cry".
    end;
end;

procedure TCCMain.RC4BrowseBtnClick(Sender: TObject);
begin
  if RC4OpenDialog.Execute then
    begin
      RC4FileNameEdit.Text := RC4OpenDialog.FileName; // Dateiname fr die RC4/CS2 verschlsselte Datei per Datei-ffnen-Dialog erfragen.
      PlaintextFileNameEdit.Text := RC4FileNameEdit.Text + '.pln'; // Der Klartext-Dateiname ist der RC4/CS2 Dateiname mit angehngtem ".pln".
      BFFileNameEdit.Text := ''; // Fr die *** verschlsselte Datei wird kein Name bentigt.
    end;
end;

procedure TCCMain.BFBrowseBtnClick(Sender: TObject);
begin
  if BFOpenDialog.Execute then
    begin
      BFFileNameEdit.Text := BFOpenDialog.FileName; // Dateiname fr die *** verschlsselte Datei per Datei-ffnen-Dialog erfragen.
      PlaintextFileNameEdit.Text := BFFileNameEdit.Text + '.pln'; // Der Klartext-Dateiname ist der Dateiname der *** verschlsselten Datei mit angehngtem ".pln".
      RC4FileNameEdit.Text := ''; // Fr die RC4/CS2 verschlsselte Datei wird kein Name bentigt.
    end;
end;

procedure TCCMain.ber1Click(Sender: TObject);
begin
  AboutBox.Show; // "ber"-Fenster anzeigen.
end;

procedure TCCMain.FormCreate(Sender: TObject);
begin
  randomize; // Initialisieren des Zufallsgenerators.
  timeBeginPeriod(1); // Zeitgeber starten.
end;

function ReadFileToString(Filename : string) : string;
var
  filehandle : file of char;
  byte       : char;
  data       : string;
begin
  AssignFile(filehandle, Filename); // Dem filehandle einen Dateinamen zuweisen.
  Reset(filehandle); // Datei zum Lesen ffnen.
  data := ''; // Dafr sorgen, da der String leer ist.
  while not eof(filehandle) do // Bis zum Dateiende:
    begin
      read(filehandle, byte); // Ein Byte lesen.
      data := data + byte; // An den String anhngen.
    end;
  closefile(filehandle); // filehandle schlieen.
  result := data; // String zurckgeben.
end;

procedure WriteStringToFile(Filename, Data : string);
var
  filehandle : file of char;
  i          : Longint;
begin
  AssignFile(filehandle, Filename); // Dem filehandle einen Dateinamen zuweisen.
  Rewrite(filehandle); // Datei zum Lesen ffnen.
  for i := 1 to length(Data) do // Jedes Byte aus Data...
    write(filehandle, Data[i]); // ...in die Datei schreiben.
  closefile(filehandle); // filehandle schlieen.
end;

procedure TCCMain.RC4EncryptBtnClick(Sender: TObject);
var
  CS   : TCipherSaber;
  Data, Timestring : string;
  starttime, endtime : longword;
begin
  Panel1.Color := clRed; // Rote Anzeige bedeutet, dass gerade eine Datei gelesen oder geschrieben wird.
  Application.ProcessMessages; // Fenster neu zeichnen, Nachrichten abarbeiten.
  Data := ReadFileToString(PlaintextFilenameEdit.Text); // Daten aus der Datei holen.
  Panel1.Color := clGreen; // Es wird gerade verschlsselt.
  Application.ProcessMessages; // Fenster neu zeichnen, Nachrichten abarbeiten.
  starttime := timeGetTime(); // Zeit zu Beginn der Verschlsselung.
  CS := TCipherSaber.ApplyCS2(Key.Text, Data, true, Options.cs2_n.Value); // CipherSaber Objekt initialisieren.
  CS.ApplyCipher; // Verschlsselung durchfhren.
  Data := CS.GetData; // Verschlsselte Daten holen.
  CS.Destroy; // CipherSaber Objekt wieder vernichten.
  endtime := timeGetTime(); // Zeit am Ende der Verschlsselung.
  Timestring := RC4TimeLabel.Caption; // Temporr die Caption des Labels in eine Variable berfhren.
  Delete(Timestring, 1, Pos('/', Timestring) - 1); // Alles vor dem / entfernen.
  RC4TimeLabel.Caption := inttostr(endtime - starttime) + 'ms' + Timestring; // Label aus der Differenz der beiden Zeiten und dem temporren String zusammenfgen.
  Panel1.Color := clRed; // Rote Anzeige bedeutet, dass gerade eine Datei gelesen oder geschrieben wird.
  Application.ProcessMessages; // Fenster neu zeichnen, Nachrichten abarbeiten.
  WriteStringToFile(RC4FilenameEdit.Text, Data); // Daten in Datei schreiben.
  Panel1.Color := clBtnFace; // Fertig. Keine besondere Farbe.
end;

procedure TCCMain.RC4DecryptBtnClick(Sender: TObject);
var
  CS   : TCipherSaber;
  Data, Timestring : string;
  starttime, endtime : longword;
begin
  Panel1.Color := clRed; // Rote Anzeige bedeutet, dass gerade eine Datei gelesen oder geschrieben wird.
  Application.ProcessMessages; // Fenster neu zeichnen, Nachrichten abarbeiten.
  Data := ReadFileToString(RC4FilenameEdit.Text); // Daten aus der Datei holen.
  Panel1.Color := clBlue; // Es wird gerade entschlsselt.
  Application.ProcessMessages; // Fenster neu zeichnen, Nachrichten abarbeiten.
  starttime := timeGetTime(); // Zeit zu Beginn der Entschlsselung.
  CS := TCipherSaber.ApplyCS2(Key.Text, Data, false, Options.cs2_n.Value); // CipherSaber Objekt initialisieren.
  CS.ApplyCipher; // Entschlsselung durchfhren.
  Data := CS.GetData; // Entschlsselte Daten holen.
  CS.Destroy; // CipherSaber Objekt wieder vernichten.
  endtime := timeGetTime(); // Zeit am Ende der Entschlsselung.
  Timestring := RC4TimeLabel.Caption; // Temporr die Caption des Labels in eine Variable berfhren.
  Delete(Timestring, Pos('/', Timestring) + 1, Length(Timestring)); // Alles nach dem / entfernen.
  RC4TimeLabel.Caption := Timestring + inttostr(endtime - starttime) + 'ms'; // Label aus der Differenz der beiden Zeiten und dem temporren String zusammenfgen.
  Panel1.Color := clRed; // Rote Anzeige bedeutet, dass gerade eine Datei gelesen oder geschrieben wird.
  Application.ProcessMessages; // Fenster neu zeichnen, Nachrichten abarbeiten.
  WriteStringToFile(PlaintextFilenameEdit.Text, Data); // Daten in Datei schreiben.
  Panel1.Color := clBtnFace; // Fertig. Keine besondere Farbe.
end;

procedure TCCMain.FormDestroy(Sender: TObject);
var
  i    : Integer;
  temp : string;
begin
  timeEndPeriod(1); // Zeitgeber beenden.
  SetLength(temp, 246); // Maximale Schlssellnge (fr RC4).
  for i := 1 to 246 do // Jedes Byte des Schlssels...
    temp := chr(0); // ...wird auf 0 gesetzt.
  Key.Text := temp;
end;

procedure TCCMain.BFEncryptBtnClick(Sender: TObject);
var
  Data, Timestring : String;
  BF : TBlowfish;
  starttime, endtime : longword;
begin
  Panel1.Color := clRed; // Rote Anzeige bedeutet, dass gerade eine Datei gelesen oder geschrieben wird.
  Application.ProcessMessages; // Fenster neu zeichnen, Nachrichten abarbeiten.
  Data := ReadFileToString(PlaintextFilenameEdit.Text); // Daten aus der Datei holen.
  Panel1.Color := clGreen; // Es wird gerade verschlsselt.
  Application.ProcessMessages; // Fenster neu zeichnen, Nachrichten abarbeiten.
  if Options.BFModeComboBox.ItemIndex = 0 then begin // ECB?
    starttime := timeGetTime(); // Zeit zu Beginn der Verschlsselung.
    BF := TBlowfish.Blowfish_Init(Key.Text); // Blowfish Objekt initialisieren.
    BF.Encipher(Data); // Verschlsselung durchfhren.
    BF.Destroy; // Blowfish Objekt wieder vernichten.
    endtime := timeGetTime(); // Zeit am Ende der Verschlsselung.
  end else begin
    starttime := timeGetTime(); // Zeit zu Beginn der Verschlsselung.
    BF := TBlowfish.Blowfish_Init(Key.Text); // Blowfish Objekt initialisieren.
    BF.Encipher_CBC(Data); // Verschlsselung durchfhren.
    BF.Destroy; // Blowfish Objekt wieder vernichten.
    endtime := timeGetTime(); // Zeit am Ende der Verschlsselung.
  end;
  Timestring := BFTimeLabel.Caption; // Temporr die Caption des Labels in eine Variable berfhren.
  Delete(Timestring, 1, Pos('/', Timestring) - 1); // Alles vor dem / entfernen.
  BFTimeLabel.Caption := inttostr(endtime - starttime) + 'ms' + Timestring; // Label aus der Differenz der beiden Zeiten und dem temporren String zusammenfgen.
  Panel1.Color := clRed; // Rote Anzeige bedeutet, dass gerade eine Datei gelesen oder geschrieben wird.
  Application.ProcessMessages; // Fenster neu zeichnen, Nachrichten abarbeiten.
  WriteStringToFile(BFFilenameEdit.Text, Data); // Daten in Datei schreiben.
  Panel1.Color := clBtnFace; // Fertig. Keine besondere Farbe.
end;

procedure TCCMain.BFDecryptBtnClick(Sender: TObject);
var
  Data, Timestring : String;
  BF : TBlowfish;
  starttime, endtime : longword;
begin
  Panel1.Color := clRed; // Rote Anzeige bedeutet, dass gerade eine Datei gelesen oder geschrieben wird.
  Application.ProcessMessages; // Fenster neu zeichnen, Nachrichten abarbeiten.
  Data := ReadFileToString(BFFilenameEdit.Text); // Daten aus der Datei holen.
  Panel1.Color := clBlue; // Es wird gerade entschlsselt.
  Application.ProcessMessages; // Fenster neu zeichnen, Nachrichten abarbeiten.
  if Options.BFModeComboBox.ItemIndex = 0 then begin // ECB?
    starttime := timeGetTime(); // Zeit zu Beginn der Entschlsselung.
    BF := TBlowfish.Blowfish_Init(Key.Text); // Blowfish Objekt initialisieren.
    BF.Decipher(Data); // Entschlsselung durchfhren.
    BF.Destroy; // Blowfish Objekt wieder vernichten.
    endtime := timeGetTime(); // Zeit am Ende der Entschlsselung.
  end else begin
    starttime := timeGetTime(); // Zeit zu Beginn der Entschlsselung.
    BF := TBlowfish.Blowfish_Init(Key.Text); // Blowfish Objekt initialisieren.
    BF.Decipher_CBC(Data); // Entschlsselung durchfhren.
    BF.Destroy; // Blowfish Objekt wieder vernichten.
    endtime := timeGetTime(); // Zeit am Ende der Entschlsselung.
  end;
  Timestring := BFTimeLabel.Caption; // Temporr die Caption des Labels in eine Variable berfhren.
  Delete(Timestring, Pos('/', Timestring) + 1, Length(Timestring)); // Alles nach dem / entfernen.
  BFTimeLabel.Caption := Timestring + inttostr(endtime - starttime) + 'ms'; // Label aus der Differenz der beiden Zeiten und dem temporren String zusammenfgen.
  Panel1.Color := clRed; // Rote Anzeige bedeutet, dass gerade eine Datei gelesen oder geschrieben wird.
  Application.ProcessMessages; // Fenster neu zeichnen, Nachrichten abarbeiten.
  WriteStringToFile(PlaintextFilenameEdit.Text, Data); // Daten in Datei schreiben.
  Panel1.Color := clBtnFace; // Fertig. Keine besondere Farbe.
end;

// Diese Prozedur ist rein zur Feststellung der Geschwindigkeitsdifferenzen. Sie liest
// den Inhalt der Klartext-Datei, verschlsselt ihn mit RC4/CS2, entschlsselt ihn,
// verschlsselt ihn mit Blowfish und entschlsselt ihn erneut. Bei jedem Verfahren wird
// die Zeit gemessen und angezeigt.
procedure TCCMain.Geschwindigkeitstest1Click(Sender: TObject);
var
  Data, Timestring : String;
  BF : TBlowfish;
  CS : TCipherSaber;
  starttime, endtime : longword;
begin
  Panel1.Color := clRed; // Rote Anzeige bedeutet, dass gerade eine Datei gelesen oder geschrieben wird.
  Application.ProcessMessages; // Fenster neu zeichnen, Nachrichten abarbeiten.
  Data := ReadFileToString(PlaintextFilenameEdit.Text); // Daten aus der Datei holen.
  Panel1.Color := clGreen; // Es wird gerade verschlsselt.
  Application.ProcessMessages; // Fenster neu zeichnen, Nachrichten abarbeiten.
  starttime := timeGetTime(); // Zeit zu Beginn der Verschlsselung.
  CS := TCipherSaber.ApplyCS2(Key.Text, Data, true, Options.cs2_n.Value); // CipherSaber Objekt initialisieren.
  CS.ApplyCipher; // Verschlsselung durchfhren.
  Data := CS.GetData; // Verschlsselte Daten holen.
  CS.Destroy; // CipherSaber Objekt wieder vernichten.
  endtime := timeGetTime(); // Zeit am Ende der Verschlsselung.
  Timestring := RC4TimeLabel.Caption; // Temporr die Caption des Labels in eine Variable berfhren.
  Delete(Timestring, 1, Pos('/', Timestring) - 1); // Alles vor dem / entfernen.
  RC4TimeLabel.Caption := inttostr(endtime - starttime) + 'ms' + Timestring; // Label aus der Differenz der beiden Zeiten und dem temporren String zusammenfgen.
  Panel1.Color := clBlue; // Es wird gerade entschlsselt.
  Application.ProcessMessages; // Fenster neu zeichnen, Nachrichten abarbeiten.
  starttime := timeGetTime(); // Zeit zu Beginn der Entschlsselung.
  CS := TCipherSaber.ApplyCS2(Key.Text, Data, false, Options.cs2_n.Value); // CipherSaber Objekt initialisieren.
  CS.ApplyCipher; // Entschlsselung durchfhren.
  Data := CS.GetData; // Entschlsselte Daten holen.
  CS.Destroy; // CipherSaber Objekt wieder vernichten.
  endtime := timeGetTime(); // Zeit am Ende der Entschlsselung.
  Timestring := RC4TimeLabel.Caption; // Temporr die Caption des Labels in eine Variable berfhren.
  Delete(Timestring, Pos('/', Timestring) + 1, Length(Timestring)); // Alles nach dem / entfernen.
  RC4TimeLabel.Caption := Timestring + inttostr(endtime - starttime) + 'ms'; // Label aus der Differenz der beiden Zeiten und dem temporren String zusammenfgen.
  if Options.BFModeComboBox.ItemIndex = 0 then begin // ECB?
    Panel1.Color := clGreen; // Es wird gerade verschlsselt.
    Application.ProcessMessages; // Fenster neu zeichnen, Nachrichten abarbeiten.
    starttime := timeGetTime(); // Zeit zu Beginn der Verschlsselung.
    BF := TBlowfish.Blowfish_Init(Key.Text); // Blowfish Objekt initialisieren.
    BF.Encipher(Data); // Verschlsselung durchfhren.
    BF.Destroy; // Blowfish Objekt wieder vernichten.
    endtime := timeGetTime(); // Zeit am Ende der Verschlsselung.
    Timestring := BFTimeLabel.Caption; // Temporr die Caption des Labels in eine Variable berfhren.
    Delete(Timestring, 1, Pos('/', Timestring) - 1); // Alles vor dem / entfernen.
    BFTimeLabel.Caption := inttostr(endtime - starttime) + 'ms' + Timestring; // Label aus der Differenz der beiden Zeiten und dem temporren String zusammenfgen.
    Panel1.Color := clBlue; // Es wird gerade entschlsselt.
    Application.ProcessMessages; // Fenster neu zeichnen, Nachrichten abarbeiten.
    starttime := timeGetTime(); // Zeit zu Beginn der Entschlsselung.
    BF := TBlowfish.Blowfish_Init(Key.Text); // Blowfish Objekt initialisieren.
    BF.Decipher(Data); // Entschlsselung durchfhren.
    BF.Destroy; // Blowfish Objekt wieder vernichten.
    endtime := timeGetTime(); // Zeit am Ende der Entschlsselung.
    Timestring := BFTimeLabel.Caption; // Temporr die Caption des Labels in eine Variable berfhren.
    Delete(Timestring, Pos('/', Timestring) + 1, Length(Timestring)); // Alles nach dem / entfernen.
  end else begin
    Panel1.Color := clGreen; // Es wird gerade verschlsselt.
    Application.ProcessMessages; // Fenster neu zeichnen, Nachrichten abarbeiten.
    starttime := timeGetTime(); // Zeit zu Beginn der Verschlsselung.
    BF := TBlowfish.Blowfish_Init(Key.Text); // Blowfish Objekt initialisieren.
    BF.Encipher_CBC(Data); // Verschlsselung durchfhren.
    BF.Destroy; // Blowfish Objekt wieder vernichten.
    endtime := timeGetTime(); // Zeit am Ende der Verschlsselung.
    Timestring := BFTimeLabel.Caption; // Temporr die Caption des Labels in eine Variable berfhren.
    Delete(Timestring, 1, Pos('/', Timestring) - 1); // Alles vor dem / entfernen.
    BFTimeLabel.Caption := inttostr(endtime - starttime) + 'ms' + Timestring; // Label aus der Differenz der beiden Zeiten und dem temporren String zusammenfgen.
    Panel1.Color := clBlue; // Es wird gerade entschlsselt.
    Application.ProcessMessages; // Fenster neu zeichnen, Nachrichten abarbeiten.
    starttime := timeGetTime(); // Zeit zu Beginn der Entschlsselung.
    BF := TBlowfish.Blowfish_Init(Key.Text); // Blowfish Objekt initialisieren.
    BF.Decipher_CBC(Data); // Entschlsselung durchfhren.
    BF.Destroy; // Blowfish Objekt wieder vernichten.
    endtime := timeGetTime(); // Zeit am Ende der Entschlsselung.
    Timestring := BFTimeLabel.Caption; // Temporr die Caption des Labels in eine Variable berfhren.
    Delete(Timestring, Pos('/', Timestring) + 1, Length(Timestring)); // Alles nach dem / entfernen.
  end;
  BFTimeLabel.Caption := Timestring + inttostr(endtime - starttime) + 'ms'; // Label aus der Differenz der beiden Zeiten und dem temporren String zusammenfgen.
  Panel1.Color := clBtnFace; // Fertig. Keine besondere Farbe.
end;

procedure TCCMain.Optionen1Click(Sender: TObject);
begin
  Options.Show;
end;

end.
